#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int




class COMBAT_EVENT_DATA : public GameEvent
{
public:
   void Export(JWriter& jw);
   void Read(JReader& event, JReader& jr);

   BOOL m_UseOutdoorMap; // set at run-time as event activates
   eventDistType distance;
   eventDirType direction;
   eventSurpriseType m_eSurprise;
   eventSurpriseType m_eTEMPsurprise;
   BOOL autoApproach;
   BOOL outdoors;
   BOOL noMonsterTreasure;
   BOOL partyNeverDies;
   BOOL partyNoExperience;
   BOOL noMagic;
   BOOL randomMonster;
   CString DeathSound;
   CString MoveSound;
   CString TurnUndeadSound;
   int monsterMorale;
   eventTurnUndeadModType turningMod;
   MONSTER_EVENT_DATA monsters;
   BACKGROUND_SOUND_DATA bgSounds;
   BOOL needDeathSprite;
   BOOL needDyingSprite;
};




void Event_Combat(JReader& event, JReader& details, JWriter& jw)
{
  COMBAT_EVENT_DATA combat_event_data;
  combat_event_data.Read(event, details);
  combat_event_data.Export(jw);
}


void COMBAT_EVENT_DATA::Export(JWriter& jw)
{
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndQuotedNonBlank(JKEY_DEATHSOUND,DeathSound);
  jw.NameAndQuotedNonBlank(JKEY_MOVESOUND,MoveSound);
  jw.NameAndQuotedNonBlank(JKEY_TURNUNDEADSOUND,TurnUndeadSound);
  jw.NameAndEnum(JKEY_DISTANCE, distance);
  jw.NameAndEnum(JKEY_DIRECTION, direction);
  jw.NameAndEnum(JKEY_SURPRISE, m_eSurprise);
  jw.NameAndBool(JKEY_AUTOAPPROACH, autoApproach);
  jw.NameAndBool(JKEY_OUTDOORS, outdoors);
  jw.NameAndBool(JKEY_MONSTERTREASURE, !noMonsterTreasure);
  jw.NameAndBool(JKEY_PARTYNEVERDIES, partyNeverDies);
  jw.NameAndBool(JKEY_NOMAGIC, noMagic);
  jw.NameAndValue(JKEY_MONSTERMORALE, monsterMorale);
  jw.NameAndEnum(JKEY_TURNMODIFIER, turningMod);
  jw.NameAndBool(JKEY_RANDOMMONSTER, randomMonster);
  jw.NameAndBool(JKEY_PARTYGAINSEXP, !partyNoExperience);
  bgSounds.Export(jw);
  monsters.Export(jw);
  jw.EndList();
}

void COMBAT_EVENT_DATA::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, Combat);
  details.NameAndQuotedNonBlank(JKEY_DEATHSOUND,DeathSound);
  details.NameAndQuotedNonBlank(JKEY_MOVESOUND,MoveSound);
  details.NameAndQuotedNonBlank(JKEY_TURNUNDEADSOUND,TurnUndeadSound);
  details.NameAndEnum(JKEY_DISTANCE, distance);
  details.NameAndEnum(JKEY_DIRECTION, direction);
  details.NameAndEnum(JKEY_SURPRISE, m_eSurprise);
  details.NameAndBool(JKEY_AUTOAPPROACH, autoApproach);
  details.NameAndBool(JKEY_OUTDOORS, outdoors);
  BOOL monsterTreasure;
  details.NameAndBool(JKEY_MONSTERTREASURE, monsterTreasure);
  noMonsterTreasure = !monsterTreasure;
  details.NameAndBool(JKEY_PARTYNEVERDIES, partyNeverDies);
  details.NameAndBool(JKEY_NOMAGIC, noMagic);
  details.NameAndValue(JKEY_MONSTERMORALE, monsterMorale);
  details.NameAndEnum(JKEY_TURNMODIFIER, turningMod);
  details.NameAndBool(JKEY_RANDOMMONSTER, randomMonster);
  BOOL partyExperience;
  details.NameAndBool(JKEY_PARTYGAINSEXP, partyExperience);
  partyNoExperience = !partyExperience;
  bgSounds.Read(details);
  monsters.Read(details);
  return;
}
