
#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int

class ENCOUNTER_DATA : public GameEvent
{
public:

  void Export(JWriter& jw);
  void Read(JReader& event, JReader& jr);
  BYTE currDist;
  eventDistType distance;
  int monsterSpeed;
  encounterButtonResultType zeroRangeResult;
  DWORD combatChain;
  DWORD talkChain;
  DWORD escapeChain;
  long Unused;   
  ENCOUNTER_BUTTON_DATA buttons;
};


void ENCOUNTER_DATA::Export(JWriter& jw)
{
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndEnum(JKEY_DISTANCE, distance);
  jw.NameAndValue(JKEY_MONSTERSPEED, monsterSpeed);
  jw.NameAndValue(JKEY_ZERORANGERESULT, zeroRangeResult);
  jw.NameAndValue(JKEY_COMBATCHAIN, combatChain);
  jw.NameAndValue(JKEY_TALKCHAIN, talkChain);
  jw.NameAndValue(JKEY_ESCAPECHAIN, escapeChain);
  buttons.Export(jw);
  jw.EndList();
}
void ENCOUNTER_DATA::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, EncounterEvent);
  details.NameAndEnum("picture_distance", distance);
  details.NameAndValue("monster_speed", monsterSpeed);
  details.NameAndEnum("action_if_range_zero", zeroRangeResult);
  details.NameAndValue("combat_event", combatChain);
  details.NameAndValue("talk_event", talkChain);
  details.NameAndValue("escape_event", escapeChain);
  buttons.Read(details);
  return;
}



void Event_Encounter(JReader& event, JReader& details, JWriter& jw)
{
  ENCOUNTER_DATA encounter_data;
  encounter_data.Read(event, details);
  encounter_data.Export(jw);
}
