#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int

extern const char *QuestTypeText[];

class UTILITIES_EVENT_DATA : public GameEvent
{
public:
   void Export(JWriter& jw);
   void Read(JReader& event, JReader& jr);
  BOOL endPlay;
  MathOperationType operation;
  MultiItemCheckType itemCheck;  
  BYTE mathItemType;
  BYTE resultItemType;
  WORD mathAmount;
  int  mathItemIndex;  
  int  resultItemIndex;
  SPECIAL_OBJECT_EVENT_LIST items;
};



void Event_Utilities(JReader& event, JReader& details, JWriter& jw)
{
  UTILITIES_EVENT_DATA utilities_event_data;
  utilities_event_data.Read(event, details);
  utilities_event_data.Export(jw);
}


void UTILITIES_EVENT_DATA::Export(JWriter& jw)
{
// Jadefang says:
//For FRUA importation, a FRUA quest stage set at 128 
//should be turned into a DC quest stage set to 65001 
//but should trigger if the current stage of the quest 
//is 127. And a FRUA utilities event that sets a quest
//to 128 should probably be translated into a DC 65001
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndBool(JKEY_ENDPLAY, endPlay);
  jw.NameAndEnum(JKEY_OPERATION, operation);
  jw.NameAndEnum(JKEY_ITEMCHECK, itemCheck);
  jw.NameAndValue(JKEY_MATHAMOUNT, mathAmount);
  jw.NameAndFlags(JKEY_MATHITEMTYPE, mathItemType, 3, QuestTypeText);
  jw.NameAndValue(JKEY_MATHITEMINDEX, mathItemIndex);
  jw.NameAndFlags(JKEY_RESULTITEMTYPE, resultItemType, 3, QuestTypeText);
  jw.NameAndValue(JKEY_RESULTITEMINDEX, resultItemIndex);
  items.Export(jw);
  jw.EndList();
}
void UTILITIES_EVENT_DATA::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, Utilities);
  details.NameAndBool("force_game_exit", endPlay);
  details.NameAndEnum("multi_item_operand", operation);
  details.NameAndEnum("single_item_operand", itemCheck);
  //details.NameAndValue(JKEY_MATHAMOUNT, mathAmount);
  mathAmount = 0;
  //details.NameAndFlags(JKEY_MATHITEMTYPE, mathItemType, 3, QuestTypeText);
  //details.NameAndValue(JKEY_MATHITEMINDEX, mathItemIndex);
  //details.NameAndFlags(JKEY_RESULTITEMTYPE, resultItemType, 3, QuestTypeText);
  //details.NameAndValue(JKEY_RESULTITEMINDEX, resultItemIndex);
  {
    int i;
    for (i=0; i<6; i++)
    {
      CString itemName;
      CString key;
      SPECIAL_OBJECT_EVENT_DATA item;
      details.Optional();
      key.Format("multi_item_%d", i);
      if (!details.NameAndValue(key, itemName)) continue;
      if (itemName == "special key 1") {item.index = 0; item.ItemType = SpecialKeyType;}
      else if (itemName == "special key 1") {item.index = 0; item.ItemType = SpecialKeyType;}
      else if (itemName == "special key 2") {item.index = 1; item.ItemType = SpecialKeyType;}
      else if (itemName == "special key 3") {item.index = 2; item.ItemType = SpecialKeyType;}
      else
      {
        details.PrintError("Unknown Special Item");
        continue;
      };
      items.list.Add(item);
    };
  }
  return;
}
