
#include "stdafx.h"
#include "Translate.h"
#include "Events.h"

#define Str details.Fetch_String
#define Int details.Fetch_Int

class WHO_TRIES_EVENT_DATA : public GameEvent
{
public:
  void Export(JWriter& jw);
  void Read(JReader& event, JReader& jr);
  BOOL alwaysSucceeds;
  BOOL alwaysFails;
  BOOL checkSTR;
  BOOL checkINT;
  BOOL checkWIS;
  BOOL checkDEX;
  BOOL checkCON;
  BOOL checkCHA;
  BOOL checkPP;
  BOOL checkOL;
  BOOL checkFT;
  BOOL checkMS;
  BOOL checkHS;
  BOOL checkHN;
  BOOL checkCW;
  BOOL checkRL;
  BYTE strBonus;
  BOOL compareToDie; // if false, then compareDie is actual compare value
  passwordActionType successAction;
  passwordActionType failAction;
  int  compareDie;   // dice sides, or actual compare value
  int  NbrTries;
  int  currTry;
  long Unused;
  DWORD successChain;
  DWORD failChain;
  TRANSFER_DATA successTransferData;
  TRANSFER_DATA failTransferData;
};





void Event_WhoTries(JReader& event, JReader& details, JWriter& jw)
{
  WHO_TRIES_EVENT_DATA who_tries_event_data;
  who_tries_event_data.Read(event, details);
  who_tries_event_data.Export(jw);
}

void WHO_TRIES_EVENT_DATA::Export(JWriter& jw)
{
  GameEvent::Export(jw);
  jw.StartList(JKEY_PARTICULAR);
  jw.NameAndBool(JKEY_ALWAYSSUCCEEDS, alwaysSucceeds);
  jw.NameAndBool(JKEY_ALWAYSFAILS, alwaysFails);
  jw.NameAndBool(JKEY_CHECKSTR, checkSTR);
  jw.NameAndBool(JKEY_CHECKINT, checkINT);
  jw.NameAndBool(JKEY_CHECKWIS, checkWIS);
  jw.NameAndBool(JKEY_CHECKDEX, checkDEX);
  jw.NameAndBool(JKEY_CHECKCON, checkCON);
  jw.NameAndBool(JKEY_CHECKCHA, checkCHA);
  jw.NameAndBool(JKEY_CHECKPP, checkPP);
  jw.NameAndBool(JKEY_CHECKOL, checkOL);
  jw.NameAndBool(JKEY_CHECKFT, checkFT);
  jw.NameAndBool(JKEY_CHECKMS, checkMS);
  jw.NameAndBool(JKEY_CHECKHS, checkHS);
  jw.NameAndBool(JKEY_CHECKHN, checkHN);
  jw.NameAndBool(JKEY_CHECKCW, checkCW);
  jw.NameAndBool(JKEY_CHECKRL, checkRL);
  jw.NameAndValue(JKEY_STRBONUS, strBonus);
  jw.NameAndBool(JKEY_COMPARETODIE, compareToDie);
  jw.NameAndValue(JKEY_DIESIDES, compareDie);
  jw.NameAndValue(JKEY_NUMBEROFTRIES, NbrTries);
  jw.NameAndEnum(JKEY_SUCCESSACTION, successAction);
  jw.NameAndValue(JKEY_SUCCESSCHAIN, successChain);
  jw.NameAndEnum(JKEY_FAILACTION, failAction);
  jw.NameAndValue(JKEY_FAILCHAIN, failChain);
  successTransferData.Export(jw, JKEY_SUCCESSTRANSFER);
  failTransferData.Export(jw, JKEY_FAILTRANSFER);
  jw.EndList();
}

void WHO_TRIES_EVENT_DATA::Read(JReader& event, JReader& details)
{
  GameEvent::Read(event, WhoTries);
  alwaysSucceeds = FALSE; //details.NameAndBool(JKEY_ALWAYSSUCCEEDS, alwaysSucceeds);
  alwaysFails = FALSE;    //details.NameAndBool(JKEY_ALWAYSFAILS, alwaysFails);

  {
    CString op;
    details.NameAndValue("check_operation", op);
    if      (op == "compare intelligence") checkINT = true;
    else if (op == "always succeed")       alwaysSucceeds = TRUE;
    else details.PrintError("Cannot determine WHO TRIES operation");
  };

  //details.NameAndBool(JKEY_CHECKSTR, checkSTR);
  //details.NameAndBool(JKEY_CHECKINT, checkINT);
  //details.NameAndBool(JKEY_CHECKWIS, checkWIS);
  //details.NameAndBool(JKEY_CHECKDEX, checkDEX);
  //details.NameAndBool(JKEY_CHECKCON, checkCON);
  //details.NameAndBool(JKEY_CHECKCHA, checkCHA);
  //details.NameAndBool(JKEY_CHECKPP, checkPP);
  //details.NameAndBool(JKEY_CHECKOL, checkOL);
  //details.NameAndBool(JKEY_CHECKFT, checkFT);
  //details.NameAndBool(JKEY_CHECKMS, checkMS);
  //details.NameAndBool(JKEY_CHECKHS, checkHS);
  //details.NameAndBool(JKEY_CHECKHN, checkHN);
  //details.NameAndBool(JKEY_CHECKCW, checkCW);
  //details.NameAndBool(JKEY_CHECKRL, checkRL);
  details.NameAndValue("check_value", strBonus);
  compareToDie = 1; //details.NameAndBool(JKEY_COMPARETODIE, compareToDie);
  compareDie =  12; //details.NameAndValue(JKEY_DIESIDES, compareDie);

  details.NameAndValue("num_attempts_allowed", NbrTries);
  details.NameAndEnum("success_action", successAction);
  details.NameAndValue("success_event", successChain);
  details.NameAndEnum("fail_action", failAction);
  details.NameAndValue("fail_event", failChain);
  details.NameAndValue("text", text);
  details.NameAndValue("success_text", text2);
  details.NameAndValue("fail_text", text3);
  //successTransferData.Read(details, JKEY_SUCCESSTRANSFER);
  //failTransferData.Read(details, JKEY_FAILTRANSFER);
  return;
}
