#include "stdafx.h"
#include "Translate.h"


#define Str mapGrid.Fetch_String
#define Int mapGrid.Fetch_Int

CArray <CELL, CELL&> cells;

int WallNum(const CString& name, CString *wallNames)
{
  int i;
  for (i=0; i<16; i++)
  {
    if (name == wallNames[i]) return i;
  };
  if (name == "none") return 0;
  printf("Cannot determine wall graphic mapping for %s\n", name);
  return 0;
}

const char *WallBlockage(const CString& name)
{
  if (name == "Open") return "Open";
  if (name == "Blocked") return "Blocked";
  return "????";
}


void MapGrid(JReader& mapGrid, JWriter& jw, CString *wallNames, CString *backdropNames)
{
  CString backdrop;
  int backdropNumber = -1;
  mapGrid.NameAndValue("backdrop", backdrop);
  if (backdrop == "none")
  {
    backdrop.Empty();
  }
  if (!backdrop.IsEmpty())
  {
    int i;
    for (i=0; i<5; i++)
    {
      if (backdrop == backdropNames[i])
      {
        backdropNumber = i;
        break;
      };
    };
  }
  else
  {
    backdropNumber = 0;
  };
  if (backdropNumber == -1)
  {
    printf("Cannot map backdrop name '%s'\n", backdrop);
    backdropNumber = 0;
  };
    jw.StartList();
    {
      CELL cell;
      int i[2];
      i[0] = mapGrid.Fetch_Int("x");
      i[1] = mapGrid.Fetch_Int("y");

      jw.Linefeed(false);
      jw.NameAndValue("comment FRUA json line number = ", mapGrid.LineNum());
      jw.Linefeed(true);


      jw.NameAndValue("xy", i, 2);
      jw.Linefeed(false);
      mapGrid.NameAndValue("event_id", cell.eventID);
      jw.NameAndBool("eventExists", cell.eventID != 0);
      if (cell.eventID != 0)
      {
        jw.NameAndValue("comment EventID = ", cell.eventID);
        cell.x = i[0];
        cell.y = i[1];
        cells.Add(cell);
      };
      jw.Linefeed(true);
    };
    {
      if (backdropNumber == 3)
      {
        int kkk=1;
      };
      jw.StartList("N");
      jw.Linefeed(false);
      jw.NameAndValue("wall",WallNum(Str("wall_north"), wallNames)+1);
      jw.NameAndValue("block",WallBlockage(Str("wall_north_blockage")));
      jw.NameAndValue("background", backdropNumber);
      jw.EndList();
      jw.Linefeed(true);
    };
    {
      jw.StartList("E");
      jw.Linefeed(false);
      jw.NameAndValue("wall",WallNum(Str("wall_east"), wallNames)+1);
      jw.NameAndValue("block",WallBlockage(Str("wall_east_blockage")));
      jw.NameAndValue("background", backdropNumber);
      jw.EndList();
      jw.Linefeed(true);
    };
    {
      jw.StartList("S");
      jw.Linefeed(false);
      jw.NameAndValue("wall",WallNum(Str("wall_south"), wallNames)+1);
      jw.NameAndValue("block",WallBlockage(Str("wall_south_blockage")));
      jw.NameAndValue("background", backdropNumber);
      jw.EndList();
      jw.Linefeed(true);
    };
    {
      jw.StartList("W");
      jw.Linefeed(false);
      jw.NameAndValue("wall",WallNum(Str("wall_west"), wallNames)+1);
      jw.NameAndValue("block",WallBlockage(Str("wall_west_blockage")));
      jw.NameAndValue("background", backdropNumber);
      jw.EndList();
      jw.Linefeed(true);
    };
    jw.EndList();
}

/*
CONFIG_ITEM_STATUS LEVEL::ExportCell(JWriter& jw, int x, int y)
{
  AREA_MAP_DATA *c;
  bool allDefault;
  int i[2];
  c = &area[y][x];
  allDefault =   ExportCellDir(jw, "N",c->northWall, c->northBlockage, c->northBG, true)
              && ExportCellDir(jw, "E",c->eastWall,  c->eastBlockage,  c->eastBG, true)
              && ExportCellDir(jw, "S",c->southWall, c->southBlockage, c->southBG, true)
              && ExportCellDir(jw, "W",c->westWall,  c->westBlockage,  c->westBG, true);
  if (c->event  != 0)      allDefault = false;
  if (c->zone   != 0)      allDefault = false;
  if (c->bkgrnd != 0)      allDefault = false;
  if (c->ShowDistantBG)    allDefault = false;
  if (c->DistantBGInBands) allDefault = false;
  if (!allDefault)
  {
    jw.NextEntry();
    i[0] = x;
    i[1] = y;
    jw.StartList();
    jw.NameAndValue(JKEY_XY, i, 2);
    jw.Linefeed(false);
    if (c->event != 0)            jw.NameAndValue(JKEY_EVID, c->event);
    if (c->zone != 0)             jw.NameAndValue(JKEY_ZONE, c->zone);
    if (c->bkgrnd != 0)           jw.NameAndValue(JKEY_BKDROP, c->bkgrnd);
    if (c->ShowDistantBG != 0)    jw.NameAndBool(JKEY_SHOWDISTBG, c->ShowDistantBG);
    if (c->DistantBGInBands != 0) jw.NameAndBool(JKEY_DSTBGBANDS, c->DistantBGInBands);
    jw.Linefeed(true);
    ExportCellDir(jw, "N",c->northWall, c->northBlockage, c->northBG, false);
    ExportCellDir(jw, "E",c->eastWall,  c->eastBlockage,  c->eastBG, false);
    ExportCellDir(jw, "S",c->southWall, c->southBlockage, c->southBG, false);
    ExportCellDir(jw, "W",c->westWall,  c->westBlockage,  c->westBG, false);
    jw.EndList();
  };
  return CONFIG_STAT_ok;
*/